"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.fileWriteRecuirsiveSync = exports.existsJSONOrDefaultSync = exports.mkFileDirSync = exports.isStaticFile = exports.getPossibleFilePaths = exports.mayBeIndexFileOrWithoutExtension = exports.isDirectory = exports.isMd = exports.isCss = exports.isTSFile = exports.isTypingsFile = exports.isJSFile = exports.fileRegex = void 0;
const fs_1 = __importDefault(require("fs"));
const path_1 = __importDefault(require("path"));
exports.fileRegex = /(.*)\.js$/;
const typescriptFileRegex = /(.*)\.(tsx?|jsx)$/;
const typingsRegex = /(.*)\.d\.ts$/;
const cssRegex = /(.*)\.css$/;
const mdRegex = /(.*)\.md$/;
const isJSFile = (p) => !!p.match(exports.fileRegex);
exports.isJSFile = isJSFile;
const isTypingsFile = (p) => !!p.match(typingsRegex);
exports.isTypingsFile = isTypingsFile;
const isTSFile = (p) => !!p.match(typescriptFileRegex) && !(0, exports.isTypingsFile)(p);
exports.isTSFile = isTSFile;
const isCss = (p) => !!p.match(cssRegex);
exports.isCss = isCss;
const isMd = (p) => !!p.match(mdRegex);
exports.isMd = isMd;
const isDirectory = (p) => fs_1.default.statSync(p).isDirectory();
exports.isDirectory = isDirectory;
const mayBeIndexFileOrWithoutExtension = (p) => {
    if (p.includes('.')) {
        return !p
            .split('.')
            .pop()
            .match(/[^\/]*/gm);
    }
    return !p.match(/\/$/);
};
exports.mayBeIndexFileOrWithoutExtension = mayBeIndexFileOrWithoutExtension;
const getPossibleFilePaths = (p) => [
    '.ts',
    '.tsx',
    '.js',
    '.jsx',
    '/index.ts',
    '/index.tsx',
    '/index.js',
    '/index.jsx',
].map((e) => `${p}${e}`);
exports.getPossibleFilePaths = getPossibleFilePaths;
const isStaticFile = (p) => !(0, exports.isJSFile)(p) && !(0, exports.isTypingsFile)(p) && !(0, exports.isTSFile)(p) && !(0, exports.isMd)(p);
exports.isStaticFile = isStaticFile;
const mkFileDirSync = (p) => {
    const dir = path_1.default.dirname(p);
    if (!fs_1.default.existsSync(dir)) {
        fs_1.default.mkdirSync(dir, { recursive: true });
    }
};
exports.mkFileDirSync = mkFileDirSync;
const existsJSONOrDefaultSync = (p, defaultValue) => fs_1.default.existsSync(p)
    ? JSON.parse(fs_1.default.readFileSync(p).toString('utf-8'))
    : defaultValue;
exports.existsJSONOrDefaultSync = existsJSONOrDefaultSync;
const fileWriteRecuirsiveSync = (p, data) => {
    (0, exports.mkFileDirSync)(p);
    fs_1.default.writeFileSync(p, data);
};
exports.fileWriteRecuirsiveSync = fileWriteRecuirsiveSync;
//# sourceMappingURL=fsAddons.js.map