import { ConfigFile } from "../config";
import ts from 'typescript';
export declare const readFiles: (matchFunction: (p: string) => boolean) => (p: string) => Promise<string[]>;
export declare const createTwinFile: (fileToTransform: string, extension?: string | undefined) => string;
export declare const hasTwinFile: (fileToTransform: string, config: ConfigFile, extension: string) => string | undefined;
export declare const injectHtmlFile: ({ fileToTransform, config, }: {
    fileToTransform: string;
    config: ConfigFile;
}) => Promise<{
    name: string;
    code: {
        pages?: import("./module").Page[] | undefined;
        content?: string | undefined;
    } | undefined;
}>;
export declare const generateBasicTypingsFiles: (config: ConfigFile) => Promise<void>;
export declare const generateTypingsFiles: ({ name, schema, config, }: {
    name: string;
    schema: string;
    config: ConfigFile;
}) => Promise<void>;
export declare const transformFiles: ({ config }: {
    config: ConfigFile;
}) => Promise<void>;
export declare const copyFile: (config: ConfigFile) => (relativeFilePath: string) => void;
export declare const copyStaticFiles: (config: ConfigFile) => void;
export declare const cleanBuild: (config: ConfigFile) => void;
export declare const transpileTS: (code: string, loader: 'ts' | 'tsx', options: ts.TranspileOptions) => Promise<import("esbuild").TransformResult>;
